unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, tscap32_rt, IniFiles, ShellAPI, SBUTils,
  SBSimpleSftp;

type
  TRGBTriple = record
    R, G, B: Integer;
  end;

type
  TDiceEdges = record
    UpperLeftX, UpperLeftY, UpperRightX, UpperRightY: Integer;
    LowerLeftX, LowerLeftY, LowerRightX, LowerRightY: Integer;
  end;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Image1: TImage;
    Cap: TtsCap32;
    Memo1: TMemo;
    Label1: TLabel;
    ReconGrid: TImage;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Image2: TImage;
    Button8: TButton;
    Button9: TButton;
    Label2: TLabel;
    Label3: TLabel;
    MatchWith: TImage;
    Button10: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Button11: TButton;
    Button12: TButton;
    CheckBox3: TCheckBox;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    Edit1: TEdit;
    Button13: TButton;
    OpenDialog1: TOpenDialog;
    Label5: TLabel;
    Edit2: TEdit;
    Button14: TButton;
    OpenDialog2: TOpenDialog;
    CheckBox4: TCheckBox;
    Label6: TLabel;
    Edit3: TEdit;
    Label7: TLabel;
    Edit4: TEdit;
    Label8: TLabel;
    Edit5: TEdit;
    Button15: TButton;
    Button16: TButton;
    SFTP: TElSimpleSFTPClient;
    Button17: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure SFTPAuthenticationFailed(Sender: TObject;
      AuthenticationType: Integer);
    procedure SFTPAuthenticationSuccess(Sender: TObject);
    procedure SFTPCloseConnection(Sender: TObject);
    procedure SFTPError(Sender: TObject; ErrorCode: Integer);
    procedure Button17Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Edges: TDiceEdges;
  normal_correction: Integer;
  thrown_history: array[0..255] of Char;
  thrown_counter: Integer;

implementation

{$R *.dfm}

function ColorToRGBTriple(Col: TColor): TRGBTriple;
begin
  with Result do begin
    R := GetRValue(Col);
    G := GetGValue(Col);
    B := GetBValue(Col);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
// Webcam aanzetten
  Cap.Connected := True;
  Button1.Enabled := False;
  Button2.Enabled := True;
  Button3.Enabled := True;
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Webcam started!');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
// Webcam uitzetten
  Cap.Connected := False;
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := False;
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Webcam stopped!');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
// Een webcam-shot nemen
  if Cap.Connected=True then
    begin
      Cap.SaveAsBMP := ExtractFileDir(Application.ExeName)+'\cap.bmp';
      Cap.PrepareManualGrab;
      Cap.ManualGrab;
      Cap.FinishManualGrab;
      Image1.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\cap.bmp');
      Image2.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\cap.bmp');
      Memo1.Lines.Add(DateTimeToStr(Now)+'> Image captured...');
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  inif: TIniFile;
begin
// Initialisatie
  SBUtils.SetLicenseKey(
    '1B7E829FC081C1788415E9079933176672F293A4BCCE78C035672F35F0D91AB3' +
    'D2D1EBC93824EDBFEA2CB623971EA31C90210B279D21A11C1FA5088A3D162A94' +
    '6738D97F9B70B3372CA1691226F4F1479E17FCDF22176B1DA3D19487B9C61E32' +
    'B61B7577F11F869D031EAD1702F852A26F91155CB956E4CB3E0814B0680A3517' +
    '6CD51FE61CF7C642E26F3D2E2AFF14AEC197B253611DEE6B6EBD429065112DD2' +
    'B7E37562C2683CAC49FE76563FC8E56E1FDC340709FB0DF16F94F85CEA044622' +
    'ADFBCE6DBBB0C7E1F5C9B0348ECB0E5995382C5A5DCE8916DAC3AFEC77F6865A' +
    'E313C65C9A9B0829DD5647E0D729F27B272D200F20D4BD8ED4A917A67295D446'
  );
  inif := TIniFile.Create(ExtractFileDir(Application.ExeName)+'\data.ini');
  Edit1.Text := Inif.ReadString('General','PyIntepreter','');
  Edit2.Text := Inif.ReadString('General','PlayScript','');
  Inif.Free;
  thrown_counter := -1;
  if FileExists(ExtractFileDir(Application.ExeName)+'\cap.bmp')=True then
    begin
      Image1.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\cap.bmp');
      Image2.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\cap.bmp');
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  x, y, z: Integer;
  color_count: array[0..255] of Integer;

  PIXELS_ZWART: Integer;

  RZB: TRGBTriple;
begin

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Monochromizing image...');

  // Het zwarte rand wegwerken door de meest nabijgelegen
  // kleur te nemen

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Removing Edges...');

  for x := 0 to Image1.Width do
    begin
      RZB := ColorToRGBTriple(Image1.Canvas.Pixels[x,4]);
      y := (RZB.R+RZb.G+RZB.B) div 3;
      Image1.Canvas.Pixels[x,0] := RGB(y,y,y);
      Image1.Canvas.Pixels[x,1] := RGB(y,y,y);
      Image1.Canvas.Pixels[x,2] := RGB(y,y,y);
      Image1.Canvas.Pixels[x,3] := RGB(y,y,y);
    end;
  for x := 0 to Image1.Width do
    begin
      RZB := ColorToRGBTriple(Image1.Canvas.Pixels[x,Image1.Height-4]);
      y := (RZB.R+RZb.G+RZB.B) div 3;
      Image1.Canvas.Pixels[x,Image1.Height-3] := RGB(y,y,y);
      Image1.Canvas.Pixels[x,Image1.Height-2] := RGB(y,y,y);
      Image1.Canvas.Pixels[x,Image1.Height-1] := RGB(y,y,y);
      Image1.Canvas.Pixels[x,Image1.Height] := RGB(y,y,y);
    end;
  for x := 0 to Image1.Height do
    begin
      RZB := ColorToRGBTriple(Image1.Canvas.Pixels[4,x]);
      y := (RZB.R+RZb.G+RZB.B) div 3;
      Image1.Canvas.Pixels[0,x] := RGB(y,y,y);
      Image1.Canvas.Pixels[1,x] := RGB(y,y,y);
      Image1.Canvas.Pixels[2,x] := RGB(y,y,y);
      Image1.Canvas.Pixels[3,x] := RGB(y,y,y);
    end;
  for x := 0 to Image1.Height do
    begin
      RZB := ColorToRGBTriple(Image1.Canvas.Pixels[Image1.Width-4,x]);
      y := (RZB.R+RZb.G+RZB.B) div 3;
      Image1.Canvas.Pixels[Image1.Width-3,x] := RGB(y,y,y);
      Image1.Canvas.Pixels[Image1.Width-2,x] := RGB(y,y,y);
      Image1.Canvas.Pixels[Image1.Width-1,x] := RGB(y,y,y);
      Image1.Canvas.Pixels[Image1.Width,x] := RGB(y,y,y);
    end;

  PIXELS_ZWART := 0;

  // Monochromiseren en daarbij kijken of de ondergrond zwart of wit is.

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Applying monochromisation and detecting background...');

  normal_correction := 0;

  for x := 0 to 255 do color_count[x] := 0;

  for x := 0 to Image1.Width do for y := 0 to Image1.Height do
    begin
      RZB := ColorToRGBTriple(Image1.Canvas.Pixels[x,y]);
      z := (RZB.R+RZb.G+RZB.B) div 3;
      color_count[z] := color_count[z]+1;
    end;

  // Kijken wat de meest voorkomende kleur is, en daar een ratio van nemen
  // om de filterwaarden te bepalen
  y := 0;
  normal_correction := 0;

  for x := 0 to 255 do
    begin
      if color_count[x]>y then
        begin
          y := color_count[x];
          normal_correction := x;
        end;
    end;

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Most present grayshade: '+IntToStr(normal_correction)+'('+IntToStr(y)+')');

  if normal_correction<35 then normal_correction := Round(normal_correction*3.4) else normal_correction := Round(normal_correction/2.2);

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Correction: '+IntToStr(normal_correction));

  // Het monochromisatieproces uitvoeren

  for x := 0 to Image1.Width do for y := 0 to Image1.Height do
    begin
      RZB := ColorToRGBTriple(Image1.Canvas.Pixels[x,y]);
      z := (RZB.R+RZb.G+RZB.B) div 3;

      if z<normal_correction then z := 0 else z := 255;

      if z=0 then PIXELS_ZWART := PIXELS_ZWART+1;

      Image1.Canvas.Pixels[x,y] := RGB(z,z,z);
    end;

  // Als de ondergrond zwart is, deze wit maken.


  if PIXELS_ZWART>(Image1.Width*Image1.Height) div 3 then
    begin
      Memo1.Lines.Add(DateTimeToStr(Now)+'> Background is DARK! Compensating...');
      // Witten vanaf links
      for y := 0 to Image1.Height do
        begin
          x := 0;
          while Image1.Canvas.Pixels[x,y]=clBlack do
            begin
              Image1.Canvas.Pixels[x,y] := clWhite;
              x := x+1;
              if x>Image1.Width then Break;
            end;
        end;
      // Witten vanaf rechts
      for y := 0 to Image1.Height do
        begin
          x := Image1.Width-1;
          while Image1.Canvas.Pixels[x,y]=clBlack do
            begin
              Image1.Canvas.Pixels[x,y] := clWhite;
              x := x-1;
              if x<0 then Break;
            end;
        end;
    end else Memo1.Lines.Add(DateTimeToStr(Now)+'> Background is LIGHT!');

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Monochromisation completed!');

end;

procedure TForm1.Button5Click(Sender: TObject);
var
  x, y, z: Integer;
  BLACK_COUNT: Integer;
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Filtering dots...');

  // Filteren van alle velden kleiner dan 4x4 pixels

  for y := 0 to Image1.Height do for x := 0 to Image1.Width do
    begin
      if Image1.Canvas.Pixels[x,y]=clBlack then
        begin
          BLACK_COUNT := 0;
          for z := x-4 to x+4 do if Image1.Canvas.Pixels[z,y]=clBlack then BLACK_COUNT := BLACK_COUNT+1;
        end;
      if BLACK_COUNT<4 then Image1.Canvas.Pixels[x,y] := clWhite;
    end;

  for x := 0 to Image1.Width do for y := 0 to Image1.Height do
    begin
      if Image1.Canvas.Pixels[x,y]=clBlack then
        begin
          BLACK_COUNT := 0;
          for z := y-4 to y+4 do if Image1.Canvas.Pixels[x,z]=clBlack then BLACK_COUNT := BLACK_COUNT+1;
        end;
      if BLACK_COUNT<4 then Image1.Canvas.Pixels[x,y] := clWhite;
    end;

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Dots filtered...');
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  x, y, sv: Integer;
begin
  // Upper Left detectie

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Detecting dice edges...');

  sv := Image1.Width;
  for y := 0 to Image1.Height do for x := 0 to Image1.Width do if Image1.Canvas.Pixels[x,y]=clBlack then
    begin
      if x<sv then
        begin
          Edges.UpperLeftX := x;
          Edges.UpperLeftY := y;
          sv := x;
        end;
    end;

  // Upper Right detectie
  sv := Image1.Height;
  for y := 0 to Image1.Height do for x := Image1.Width-1 downto 0 do if Image1.Canvas.Pixels[x,y]=clBlack then
    begin
      if y<sv then
        begin
          Edges.UpperRightX := x;
          Edges.UpperRightY := y;
          sv := y;
        end;
    end;

  // Lower Left detectie
  sv := 0;
  for y := Image1.Height-1 downto 0 do for x := 0 to Image1.Width do if Image1.Canvas.Pixels[x,y]=clBlack then
    begin
      if y>sv then
        begin
          Edges.LowerLeftX := x;
          Edges.LowerLeftY := y;
          sv := y;
        end;
    end;

  // Lower Right detectie
  sv := 0;
  for y := Image1.Height-1 downto 0 do for x := Image1.Width-1 downto 0 do if Image1.Canvas.Pixels[x,y]=clBlack then
    begin
      if x>sv then
        begin
          Edges.LowerRightX := x;
          Edges.LowerRightY := y;
          sv := x;
        end;
    end;

  // Het selectievierkant tekenen

  if CheckBox1.Checked=True then
    begin
      Image1.Canvas.Pen.Color := clRed;
      Image1.Canvas.MoveTo(Edges.UpperLeftX-1, Edges.UpperLeftY-1);

      Image1.Canvas.LineTo(Edges.UpperRightX+1, Edges.UpperRightY-1);
      Image1.Canvas.LineTo(Edges.LowerRightX+1, Edges.LowerRightY+1);
      Image1.Canvas.LineTo(Edges.LowerLeftX-1, Edges.LowerLeftY+1);
      Image1.Canvas.LineTo(Edges.UpperLeftX-1, Edges.UpperLeftY-1);
    end;

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Drawing dice edges...');

  Image2.Canvas.Pen.Color := clRed;
  Image2.Canvas.MoveTo(Edges.UpperLeftX-1, Edges.UpperLeftY-1);

  Image2.Canvas.LineTo(Edges.UpperRightX+1, Edges.UpperRightY-1);
  Image2.Canvas.LineTo(Edges.LowerRightX+1, Edges.LowerRightY+1);
  Image2.Canvas.LineTo(Edges.LowerLeftX-1, Edges.LowerLeftY+1);
  Image2.Canvas.LineTo(Edges.UpperLeftX-1, Edges.UpperLeftY-1);
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Edges detected!');
end;
procedure TForm1.Button7Click(Sender: TObject);
var
  duy, dux, ddy, ddx: Integer;
  dly, dlx, dry, drx: Integer;
  CanISeeIt: Boolean;
  attempt: Integer;
begin
// Alle operaties automatiseren
  attempt := 0;
  CanISeeIt := False;
  while CanISeeIt=False do
    begin
      // Monochromiseer, Filter, vind randen, probeer dit 3 keer
      Button4Click(Button4);
      Button5Click(Button5);
      Button6Click(Button6);
      // Kijken of de randen te "scheef" staan. In dat geval is de detectie
      // , waarschijnlijk door schaduwen, mislukt
      duy := abs(Edges.UpperLeftY-Edges.UpperRightY);
      dux := abs(Edges.UpperRightX-Edges.UpperLeftX);
      ddy := abs(Edges.LowerLeftY-Edges.LowerRightY);
      ddx := abs(Edges.LowerRightX-Edges.LowerLeftX);
      dly := abs(Edges.UpperLeftY-Edges.LowerLeftY);
      dlx := abs(Edges.UpperLeftX-Edges.LowerLeftX);
      dry := abs(Edges.UpperRightY-Edges.LowerRightY);
      drx := abs(Edges.UpperRightX-Edges.LowerRightX);
      if (abs(duy-ddy)<9) and (abs(dux-ddx)<9) and (abs(dly-dry)<9) and (abs(dlx-drx)<9) then
        begin
          CanISeeIt := True;
          Button8Click(Button8);
          Button9Click(Button9);
        end
        else if attempt<3 then
        begin
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Can''t see, waiting a second, then retrying...');
          Sleep(2500);
          Button3Click(Button3);
          Application.ProcessMessages;
        end;
      if (attempt=3) and (CanISeeIt=False) then
        begin
          CanISeeIt := true;
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Can''t lock on to dice. Please move dice to another position.!');
        end;
      attempt := attempt+1;
    end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  x, y, srcx, srcy, z: Integer;
  dx, dy, shiftx, shifty: Real;
  RZB: TRGBTriple;
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Projecting the dice on recognition grid... ');

  // Vertalen van de dobbelsteen binnen de randen naar het detectie-veld
  dy := (Edges.UpperRightY-Edges.UpperLeftY)/29;
  shifty := (Edges.LowerRightY-Edges.UpperRightY)/29;
  dx := sqrt(sqr(Edges.UpperRightX-Edges.UpperLeftX)+sqr(Edges.UpperLeftY-Edges.UpperRightY))/29;
  shiftx := (Edges.LowerLeftX-Edges.UpperLeftX)/29;
  for y := 0 to 29 do
    for x := 0 to 29 do
      begin
        srcy := Edges.UpperLeftY+Round(dy*x)+Round(shifty*y);
        srcx := Edges.UpperLeftX+Round(dx*x-1)+Round(shiftx*y);

        RZB := ColorToRGBTriple(Image2.Canvas.Pixels[srcx, srcy]);
        z := (RZB.R+RZb.G+RZB.B) div 3;

        if (z<normal_correction) or (Image2.Canvas.Pixels[srcx, srcy]=clRed) then z := 0 else z := 255;

        ReconGrid.Canvas.Pixels[x,y] :=RGB(z,z,z);
      end;

  Memo1.Lines.Add(DateTimeToStr(Now)+'> Correcting rotation deviation...');

  // Witte vlakken in de randen die voorkomen door slechte detectie van
  // edges zwart maken ivm. de vergelijkingsfunctie
  reconGrid.Canvas.Brush.Color := clBlack;
  if ((ReconGrid.Canvas.Pixels[0,0]=clWhite) and (ReconGrid.Canvas.Pixels[0,2]=clWhite) and (ReconGrid.Canvas.Pixels[2,0]=clWhite)) then ReconGrid.Canvas.FloodFill(0,0,clWhite,fsSurface);
  if ((ReconGrid.Canvas.Pixels[28,28]=clWhite) and (ReconGrid.Canvas.Pixels[28,26]=clWhite) and (ReconGrid.Canvas.Pixels[26,28]=clWhite)) then ReconGrid.Canvas.FloodFill(28,28,clWhite,fsSurface);
  if ((ReconGrid.Canvas.Pixels[0,28]=clWhite) and (ReconGrid.Canvas.Pixels[2,28]=clWhite) and (ReconGrid.Canvas.Pixels[0,26]=clWhite)) then ReconGrid.Canvas.FloodFill(0,28,clWhite,fsSurface);
  if ((ReconGrid.Canvas.Pixels[28,0]=clWhite) and (ReconGrid.Canvas.Pixels[28,2]=clWhite) and (ReconGrid.Canvas.Pixels[26,2]=clWhite)) then ReconGrid.Canvas.FloodFill(28,0,clWhite,fsSurface);
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Dice projected on Recognition Grid!');
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  x, y, z, cnt, total, detected, white_pix, white_comp: Integer;
  results: array of Integer;
  inif: TIniFile;
  defined_value: String;
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Initiating recognition...');

  // Herkenning starten...
  inif := TIniFile.Create(ExtractFileDir(Application.ExeName)+'\data.ini');
  total := inif.ReadInteger('General','total',-1);
  SetLength(results,total+1);

  // Totaal witte pixels in de herkennigsveld tellen
  white_pix := 0;
  for y := 0 to 29 do for x := 0 to 29 do if ReconGrid.Canvas.Pixels[x,y]=clWhite then white_pix := white_pix+1;

  // Voor elke geleerde dobbelsteenconfiguratie...
  for cnt := 0 to total do
    begin
      // ... laad het ...
      z := 0;
      MatchWith.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\'+IntToStr(cnt)+'.bmp');
      Application.ProcessMessages;
      white_comp := 0;
      // ... meet totaal witte pixels ...
      for y := 0 to 29 do for x := 0 to 29 do if MatchWith.Canvas.Pixels[x,y]=clWhite then white_comp := white_comp+1;
      // ... vergelijk de pixels op het bronvlak met deze op het vergelijkvlak...
      for y := 0 to 29 do for x := 0 to 29 do if (ReconGrid.Canvas.Pixels[x,y]=clWhite) and (ReconGrid.Canvas.Pixels[x,y]=MatchWith.Canvas.Pixels[x,y]) then z := z+1;
      if white_pix=0 then white_pix := 1;
      if white_comp=0 then white_comp := 1;
      // ... en bereken overeenkomstigheid volgens de formule
      // ((overeenkomend_aantal/brontotaal)+(overeenkomend_aantal/vergelijktotaal)/2)*100
      results[cnt] := Round((((z/white_pix)+(z/white_comp))/2)*100);
    end;

  z := 0;
  detected := -1;
  // Zoek het plaatje met de hoogste overeenkomstpercentage, minimaal 51%
  for cnt := 0 to total do if results[cnt]>51 then
    begin
      if results[cnt]>z then
        begin
          detected := cnt;
          z := results[cnt];
        end;
    end;
  if detected>-1 then
    begin
      // Als er iets gevonden is, laat het zien...
      Label3.Caption := inif.ReadString(IntToStr(detected),'Value','n/a');
      MatchWith.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\'+IntToStr(detected)+'.bmp');
      Memo1.Lines.Add(DateTimeToStr(Now)+'> Dice recognised! Number is: '+Label3.Caption+' ('+IntToStr(z)+'%)');
    end
    else
    begin
      // ... en anders, mits leren aanstaat, LEER!
      if CheckBox3.Checked=True then
        begin
          defined_value := InputBox('Enter value','Enter the value for this image','');
          if defined_value<>'' then
            begin
              total := total+1;
              inif.WriteString(IntToStr(total),'Value',defined_value);
              inif.WriteInteger('General','total',total);
              ReconGrid.Picture.SaveToFile(ExtractFileDir(Application.ExeName)+'\'+IntToStr(total)+'.bmp');
              Memo1.Lines.Add(DateTimeToStr(Now)+'> New dice position! Given number is: '+defined_value+'.');
            end;
        end
        else
        begin
          Label3.Caption := 'n/a';
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Can''t recognise the number on the dice. Please move the box with the dice a little.');
        end;
    end;

  SetLength(results,0);
  inif.Free;
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Recognition done!');
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  // Hetlaad de laatste webcamshot.
  if FileExists(ExtractFileDir(Application.ExeName)+'\cap.bmp')=True then
    begin
      Image1.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\cap.bmp');
      Image2.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'\cap.bmp');
    end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  // Laat het oorspronkelijke plaatje al dan niet zien
  Image2.Visible := CheckBox2.Checked;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  x: Integer;
  ThrownString: String;
begin
  // Doe de hele herkenning
  if Cap.Connected=True then
    begin
      Button3Click(Button3);
      Button7Click(Button7);
      ThrownString := '';
      // Als er niets herkend is, gooi opnieuw.
      if Label3.Caption='n/a' then ThrownString := 's';

      // Als we ook spelen...
      if CheckBox4.Checked=True then
        begin
          // En er is iets gegooid, vul de gooigeschiedenis.
          // Dit is nodig in het geval dat iemand een 6 gooit,
          // want daarna mag weer gegooid worden.
          if Label3.Caption<>'n/a' then
            begin
              Thrown_counter := thrown_counter+1;
              thrown_history[thrown_counter] := Label3.Caption[1];
            end;
          // Als 6 is gegooid, gooi opnieuw...
          if Label3.Caption='6' then ThrownString := 's' else
            begin
              // ... anders, lees alle gegooide stappen uit.
              for x := 0 to thrown_counter do
                begin
                  ThrownString := ThrownString+thrown_history[x];
                  if x<Thrown_Counter then ThrownString := ThrownString+' ';
                end;
              Thrown_counter := -1;
            end;

          Memo1.Lines.Add(DateTimeToStr(Now)+'> Initiating PlayGame script with following parameters: '+Thrownstring);
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Execute: '+Edit1.Text+' "'+Edit2.Text+'" '+Thrownstring);
          SetCurrentDir(ExtractFileDir(Edit2.Text));

          // Start de python script met de parameters van de gegooide stappen
          ShellExecute(0,'open',pchar(Edit1.Text),pchar('"'+Edit2.Text+'" '+Thrownstring),'',SW_SHOWNORMAL);
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Waiting seconds for GameScript to finish...');
          Application.ProcessMessages;
          while FileExists(ExtractFileDir(Edit2.Text)+'\leeg.txt')=False do
            begin
              Sleep(200);
              Application.ProcessMessages;
            end;
          DeleteFile(ExtractFileDir(Edit2.Text)+'\leeg.txt');
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Move made, cinematics file generated!');
          if Button15.Enabled=False then
            begin
              Memo1.Lines.Add(DateTimeToStr(Now)+'> Uploading cinematics file to '+Edit4.Text+'@'+Edit3.Text+' via SFTP...');
              SFTP.UploadFile(ExtractFileDir(Edit2.Text)+'\joints.txt', 'dump/joints.txt');
              Memo1.Lines.Add(DateTimeToStr(Now)+'> File uploaded! Removing local cinematics file...');
              DeleteFile(ExtractFileDir(Edit2.Text)+'\joints.txt');
            end;
         Memo1.Lines.Add(DateTimeToStr(Now)+'> File removed! GamePlay done.');
      end;
    end;
end;

procedure TForm1.Button12Click(Sender: TObject);
var
  Inif: TIniFile;
  total: Integer;
  defined_value: String;
begin
  // Classificeer handmatig het getal op het herkenningsvlak
  inif := TIniFile.Create(ExtractFileDir(Application.ExeName)+'\data.ini');
  total := inif.ReadInteger('General','total',-1);
  defined_value := InputBox('Enter value','Enter the value for this image','');
  if defined_value<>'' then
    begin
      total := total+1;
      inif.WriteString(IntToStr(total),'Value',defined_value);
      inif.WriteInteger('General','total',total);
      ReconGrid.Picture.SaveToFile(ExtractFileDir(Application.ExeName)+'\'+IntToStr(total)+'.bmp');
      Memo1.Lines.Add(DateTimeToStr(Now)+'> New dice position! Given number is: '+defined_value+'.');
    end;
  inif.Free;
end;

procedure TForm1.Button13Click(Sender: TObject);
var
  inif: TIniFile;
begin
  // Sla de locatie van de Python-interpreter op
  with OpenDialog1 do if Execute then
    begin
      inif := TIniFile.Create(ExtractFileDir(Application.ExeName)+'\data.ini');
      Edit1.Text := Filename;
      Inif.WriteString('General','PyIntepreter',Filename);
      Inif.Free;
      Memo1.Lines.Add(DateTimeToStr(Now)+'> Python interpreter located: '+Filename);
    end;
end;

procedure TForm1.Button14Click(Sender: TObject);
var
  inif: TIniFile;
begin
  // Sla de locatie van de Python PlayGame script op.
  with OpenDialog2 do if Execute then
    begin
      inif := TIniFile.Create(ExtractFileDir(Application.ExeName)+'\data.ini');
      Edit2.Text := Filename;
      Inif.WriteString('General','PlayScript',Filename);
      Inif.Free;
      Memo1.Lines.Add(DateTimeToStr(Now)+'> Play game, path planning and cinematics script located: '+Filename);
    end;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  // Verbind via SFTP met de server...
  SFTP.Address := Edit3.Text;
  SFTP.ClientUsername := Edit4.Text;
  SFTP.Username := Edit4.Text;
  SFTP.Password := Edit5.Text;
  Memo1.Lines.Add(DateTimeToStr(Now)+'> Connecting via SFTP to: '+Edit3.Text);
  SFTP.Open;
  Button15.Enabled := False;
  Button16.Enabled := True;
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  // Verbreek de SFTP connectie met de server. 
  SFTp.Close(True);
  Memo1.Lines.Add(DateTimeToStr(Now)+'> SFTP Disconnected!');
  Button15.Enabled := True;
  Button16.Enabled := False;
end;

procedure TForm1.SFTPAuthenticationFailed(Sender: TObject;
  AuthenticationType: Integer);
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> SFTP: Authentication failed!');
end;

procedure TForm1.SFTPAuthenticationSuccess(Sender: TObject);
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> SFTP: Authentication success, line ready!');
end;

procedure TForm1.SFTPCloseConnection(Sender: TObject);
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> SFTP: Connection closed!');
end;

procedure TForm1.SFTPError(Sender: TObject; ErrorCode: Integer);
begin
  Memo1.Lines.Add(DateTimeToStr(Now)+'> SFTP: Connection ERROR '+IntToStr(ErrorCode)+'!');
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  if Cap.Connected=True then
    begin
      if CheckBox4.Checked=True then
        begin
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Throwing dice... ');
          SetCurrentDir(ExtractFileDir(Edit2.Text));

          // Start de python script met de parameters van de gegooide stappen
          ShellExecute(0,'open',pchar(Edit1.Text),pchar('"'+Edit2.Text+'" s'),'',SW_SHOWNORMAL);
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Waiting seconds for GameScript to finish...');
          Application.ProcessMessages;
          while FileExists(ExtractFileDir(Edit2.Text)+'\leeg.txt')=False do
            begin
              Sleep(200);
              Application.ProcessMessages;
            end;
          DeleteFile(ExtractFileDir(Edit2.Text)+'\leeg.txt');
          Memo1.Lines.Add(DateTimeToStr(Now)+'> Cinematics file generated!');
          if Button15.Enabled=False then
            begin
              Memo1.Lines.Add(DateTimeToStr(Now)+'> Uploading cinematics file to '+Edit4.Text+'@'+Edit3.Text+' via SFTP...');
              SFTP.UploadFile(ExtractFileDir(Edit2.Text)+'\joints.txt', 'dump/joints.txt');
              Memo1.Lines.Add(DateTimeToStr(Now)+'> File uploaded! Removing local cinematics file...');
              DeleteFile(ExtractFileDir(Edit2.Text)+'\joints.txt');
            end;
         Memo1.Lines.Add(DateTimeToStr(Now)+'> File removed! ThrowDice done.');
      end;
    end;

end;

end.
